#!/usr/bin/env node
const JSDOM = require('jsdom')
const rds = require('react-dom/server');
const prettier = require('prettier');
const path = require('path');

const html = '<!doctype html><html><head><meta charset="utf-8"></head><body></body></html>'
const options = {}
const KEYS = []

if (!('url' in options)) { Object.assign(options, { url: 'http://localhost:3000' }) }
if (!('pretendToBeVisual' in options)) { Object.assign(options, { pretendToBeVisual: true }) }
const jsdom = new JSDOM.JSDOM(html, options)
const { window } = jsdom
const { document } = window
if (KEYS.length === 0) {
  KEYS.push(...Object.getOwnPropertyNames(window).filter((k) => !k.startsWith('_')).filter((k) => !(k in global)))
  KEYS.push('$jsdom')
}
KEYS.forEach((key) => global[key] = window[key])
global.document = document
global.window = window
window.console = global.console
global.$jsdom = jsdom

const namearg = process.argv.find((arg) => arg.includes('name='))
const [, name] = namearg.split('=')

if (!name) {
  process.exit(1);
}

const u = require(path.join(process.cwd(), `./build/html-only-examples/${name}.js`))[name]
const str = rds.renderToString(u)
const formatted = prettier.format(str, {
  config: path.join(process.cwd(), '.prettierrc'),
  parser: 'html',
  filepath: process.cwd(),
}).replace(' data-reactroot=""', '');
process.stdout.write(formatted);
